VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsITranscodeImage"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 09/2018

' IUnknown interface
' https://docs.microsoft.com/en-us/windows/desktop/api/unknwn/nn-unknwn-iunknown

' ITranscodeImage interface
' https://docs.microsoft.com/en-us/windows/desktop/api/imagetranscode/nn-imagetranscode-itranscodeimage

Option Explicit

' ----==== Const ====----
Private Const ERR_BASE As Long = 40670
Private Const CLSID_TranscodeImage As String = "{17B75166-928F-417d-9685-64AA135565C1}"
Private Const IID_ITranscodeImage As String = "{BAE86DDD-DC11-421c-B7AB-CC55D1D65C44}"

Private Enum E_vtbOffsets
    '/*** IUnknown methods ***/
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    '/*** ITranscodeImage methods ***/
    vtb_TranscodeImage
End Enum

' ----==== Variablen ====----
Private m_initialized As Boolean
Private m_Interface As Interface_Data

Public Function TranscodeImage(ByVal pShellItem As Long, ByVal uiMaxWidth As Long, _
    ByVal uiMaxHeight As Long, ByVal flags As TI_FLAGS, ByVal pvImage As Long, _
    ByRef puiWidth As Long, ByRef puiHeight As Long) As Boolean

    Dim bRet As Boolean
    Dim ppuiWidth As Long
    Dim ppuiHeight As Long

    bRet = False
    ppuiWidth = VarPtr(puiWidth)
    ppuiHeight = VarPtr(puiHeight)

    If x_OleInvoke(vtb_TranscodeImage, pShellItem, uiMaxWidth, uiMaxHeight, flags, _
        pvImage, ppuiWidth, ppuiHeight) Then

        bRet = True

    End If

    TranscodeImage = bRet
    
End Function

' ----==== Helper Func ====----
Private Sub Class_Initialize()

    m_Interface.owner = ObjPtr(Me)
    m_Interface.RaiseErrors = False

    ' Interface wird CLSID und IID erstellt
    m_initialized = InitInterface(m_Interface, CLSID_TranscodeImage, _
        IID_ITranscodeImage)

End Sub

Private Sub Class_Terminate()

    Call ReleaseInterface(m_Interface)

End Sub

Public Sub RaiseError(Optional ByVal Raise As Boolean = False)

    m_Interface.RaiseErrors = Raise

End Sub

Private Function x_OleInvoke(ByVal vtb As E_vtbOffsets, ParamArray var()) As Boolean

    Dim ret As Long

    If Not m_initialized Then

        Call InterfaceError(m_Interface, ecd_OleInvoke)

    Else

        x_OleInvoke = oleInvoke(m_Interface, vtb, ret, True, var)

    End If

End Function

Public Sub x_RaiseError()

    With m_Interface

        If .ecd Then Err.Raise ERR_BASE + .ecd, App.EXEName & _
            ".clsITranscodeImage", .etx

        .ecd = 0
        .etx = ""

    End With

End Sub

